# Reset tnt's score to 0
scoreboard players set tnt tntTime 0

# Makes TNT drop sticky_piston on break
execute at @e[type=armor_stand,tag=brancher,tag=!primed,tag=pX] if block ~-0.85 ~0.5 ~ air run summon item ~ ~0.25 ~-0.25 {Item:{id:"minecraft:sticky_piston",Count:1b},Motion:[0.075,0.2,-0.02],PickupDelay:10s,Tags:["newDrop"]}
execute at @e[type=armor_stand,tag=brancher,tag=!primed,tag=nX] if block ~0.85 ~0.5 ~ air run summon item ~ ~0.25 ~0.25 {Item:{id:"minecraft:sticky_piston",Count:1b},Motion:[-0.075,0.21,-0.02],PickupDelay:10s,Tags:["newDrop"]}
execute at @e[type=armor_stand,tag=brancher,tag=!primed,tag=pZ] if block ~ ~0.5 ~-0.85 air run summon item ~ ~0.25 ~-0.25 {Item:{id:"minecraft:sticky_piston",Count:1b},Motion:[-0.01,0.2,0.075],PickupDelay:10s,Tags:["newDrop"]}
execute at @e[type=armor_stand,tag=brancher,tag=!primed,tag=nZ] if block ~ ~0.5 ~0.85 air run summon item ~ ~0.25 ~0.25 {Item:{id:"minecraft:sticky_piston",Count:1b},Motion:[-0.01,0.2,-0.075],PickupDelay:10s,Tags:["newDrop"]}
execute at @e[type=armor_stand,tag=brancher,tag=!primed,tag=pY] if block ~ ~ ~ air run summon item ~ ~0.15 ~ {Item:{id:"minecraft:sticky_piston",Count:1b},Motion:[-0.01,0.225,0.02],PickupDelay:10s,Tags:["newDrop"]}
execute at @e[type=armor_stand,tag=brancher,tag=!primed,tag=nY] if block ~ ~1.5 ~ air run summon item ~ ~0.5 ~ {Item:{id:"minecraft:sticky_piston",Count:1b},Motion:[0.03,0.175,-0.01],PickupDelay:10s,Tags:["newDrop"]}

# Creates charms via floor crafting
execute at @e[type=item,nbt={Item:{id:"minecraft:packed_ice",Count:4b}}] run data merge entity @e[type=item,nbt={Item:{id:"minecraft:iron_ingot",Count:1b}},distance=..0.5,limit=1] {Tags:["newlyCrafted"],Item:{tag:{display:{Name:'{"text":"Charm of Swiftness","color":"yellow","italic":false}'},HideFlags:1,SwiftCharm:1,Enchantments:[{id:"minecraft:lure",lvl:1s}]}}}
execute at @e[type=item,nbt={Item:{id:"minecraft:honey_block",Count:4b}}] run data merge entity @e[type=item,nbt={Item:{id:"minecraft:gold_ingot",Count:1b}},distance=..0.5,limit=1] {Tags:["newlyCrafted"],Item:{tag:{display:{Name:'{"text":"Charm of Staying","color":"yellow","italic":false}'},HideFlags:1,StayCharm:1,Enchantments:[{id:"minecraft:lure",lvl:1s}]}}}
execute at @e[type=item,nbt={Item:{id:"minecraft:chorus_flower",Count:4b}}] run data merge entity @e[type=item,nbt={Item:{id:"minecraft:diamond",Count:1b}},distance=..0.5,limit=1] {Tags:["newlyCrafted"],Item:{tag:{display:{Name:'{"text":"Charm of Teleportation","color":"yellow","italic":false}'},HideFlags:1,TeleCharm:1,Enchantments:[{id:"minecraft:lure",lvl:1s}]}}}
execute at @e[type=item,nbt={Item:{id:"minecraft:enchanted_book",Count:1b,tag:{StoredEnchantments:[{id:"minecraft:blast_protection",lvl:4s}]}}}] run data merge entity @e[type=item,nbt={Item:{id:"minecraft:saddle",Count:1b}},distance=..0.5,limit=1] {Tags:["newlyCrafted"],Item:{tag:{display:{Name:'{"text":"TNT Mounting Apparatus","color":"yellow","italic":false}'},HideFlags:1,MountCharm:1,Enchantments:[{id:"minecraft:lure",lvl:1s}]}}}
execute at @e[type=item,tag=newlyCrafted] run particle happy_villager ~ ~0.25 ~ 0.15 0.15 0.15 1 10
execute at @e[type=item,tag=newlyCrafted] run playsound minecraft:entity.zombie.infect master @a
execute as @e[type=item,tag=newlyCrafted] at @s run kill @e[type=item,distance=..0.5,tag=!newlyCrafted]
tag @e[type=item,tag=newlyCrafted] remove newlyCrafted

# Adds charm to brancher when close
execute as @e[type=item,nbt={Item:{Count:1b,tag:{SwiftCharm:1}}}] at @s positioned ~ ~-0.5 ~ if entity @e[type=armor_stand,tag=brancher,tag=!charmSwift,tag=!charmStay,tag=!charmTele,distance=..0.5] run tag @s add usedCharm
execute at @e[type=item,nbt={Item:{Count:1b,tag:{SwiftCharm:1}}}] positioned ~ ~-0.5 ~ run tag @e[type=armor_stand,tag=brancher,tag=!charmSwift,tag=!charmStay,tag=!charmTele,distance=..0.5] add charmSwift
execute as @e[type=item,nbt={Item:{Count:1b,tag:{StayCharm:1}}}] at @s positioned ~ ~-0.5 ~ if entity @e[type=armor_stand,tag=brancher,tag=!charmSwift,tag=!charmStay,tag=!charmTele,distance=..0.5] run tag @s add usedCharm
execute at @e[type=item,nbt={Item:{Count:1b,tag:{StayCharm:1}}}] positioned ~ ~-0.5 ~ run tag @e[type=armor_stand,tag=brancher,tag=!charmSwift,tag=!charmStay,tag=!charmTele,distance=..0.5] add charmStay
execute as @e[type=item,nbt={Item:{Count:1b,tag:{TeleCharm:1}}}] at @s positioned ~ ~-0.5 ~ if entity @e[type=armor_stand,tag=brancher,tag=!charmSwift,tag=!charmStay,tag=!charmTele,tag=!charmMount,distance=..0.5] run tag @s add usedCharm
execute at @e[type=item,nbt={Item:{Count:1b,tag:{TeleCharm:1}}}] positioned ~ ~-0.5 ~ run tag @e[type=armor_stand,tag=brancher,tag=!charmSwift,tag=!charmStay,tag=!charmTele,tag=!charmMount,distance=..0.5] add charmTele
execute as @e[type=item,nbt={Item:{Count:1b,tag:{MountCharm:1}}}] at @s positioned ~ ~-0.5 ~ if entity @e[type=armor_stand,tag=brancher,tag=!charmMount,distance=..0.5] run tag @s add usedCharm
execute at @e[type=item,nbt={Item:{Count:1b,tag:{MountCharm:1}}}] positioned ~ ~-0.5 ~ run tag @e[type=armor_stand,tag=brancher,tag=!charmMount,distance=..0.5] add charmMount
# Plays effects and kills charm when used
execute at @e[type=item,tag=usedCharm] run playsound minecraft:block.lava.extinguish master @a ~ ~ ~ 0.5 1.25
execute at @e[type=item,tag=usedCharm] run particle minecraft:smoke ~ ~ ~ 0.1 0.1 0.1 0.025 10
execute if entity @e[type=armor_stand,tag=charmMount] run function tnt:mounter
kill @e[type=item,tag=usedCharm]